/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.ergebnis.boundary;

import de.ivu.elect.business.ergebnis.entity.Stimmen;

@javax.enterprise.context.ApplicationScoped // ELECT-7845
public class StimmenDAO extends AbstractStimmenDAO {

  private static final long serialVersionUID = 1L;

  @javax.inject.Inject
  private transient de.ivu.elect.jee.entity.SimpleDAO simpleDAO;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return simpleDAO.getEntityManager();
  }

  public void persist(Stimmen stimmen){
    getEntityManager().persist(stimmen);
  }

  public void remove(Stimmen stimmen){
    getEntityManager().remove(stimmen);
  }

@javax.inject.Inject
private transient de.ivu.elect.presentation.system.DAOCache daoCache;

                                                                                                                                                                                                                        
        /**
        * Name: StimmenAnzahlByStimmartUndGruppeAndCountNoFlush<br>
        * Beschreibung: Findet die Anzahl der Stimmen pro Gruppe in den angegebenen Gebieten (für die Stimmen zu einem Ergebnis). Wir für die grafische Darstellung von Stimmen benötigt.<br>
        * EJBQL: SELECT new de.ivu.elect.business.ergebnis.entity.StimmenAnzahlByStimmartUndGruppe(s.gruppe, s.stimmenart, SUM(s.anzahl)) FROM Stimmen s WHERE s.ergebnis=?1 AND s.gebiet IN (?2) GROUP BY s.gruppe, s.stimmenart<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<de.ivu.elect.business.ergebnis.entity.StimmenAnzahlByStimmartUndGruppe> findByStimmenAnzahlByStimmartUndGruppeAndCount( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.gebietsbaum.entity.Gebiet> gebiete) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Stimmen.findByStimmenAnzahlByStimmartUndGruppeAndCount" ,  ergebnis ,  gebiete  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByStimmenAnzahlByStimmartUndGruppeAndCount( ergebnis ,  gebiete  ));
        }
        return (java.util.List<de.ivu.elect.business.ergebnis.entity.StimmenAnzahlByStimmartUndGruppe>) cached;
        }
            return super.findByStimmenAnzahlByStimmartUndGruppeAndCount( ergebnis ,  gebiete  );
            }
                    
@Override
public void clear() {
super.clear();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}

}

@Override
public void flush() {
super.flush();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}
}



}